; Swordfish Structured BASIC Compiler for PICmicros.
; Version 1.1.5.1 SE Copyright Mecanique 2007
;
; C:\PIC\USBUpCounter\USBUpCounter.BAS 2010/03/24
;
 PROCESSOR PIC18F4550
 RADIX DEC
 ERRORLEVEL 2
 EXPAND ON
; SPECIAL FUNCTION REGISTERS...
SPPDATA          EQU 0X0F62
SPPCFG           EQU 0X0F63
SPPEPS           EQU 0X0F64
SPPCON           EQU 0X0F65
UFRM             EQU 0X0F66
UFRML            EQU 0X0F66
UFRMLH           EQU 0X0F67
UFRMH            EQU 0X0F67
UIR              EQU 0X0F68
UIE              EQU 0X0F69
UEIR             EQU 0X0F6A
UEIE             EQU 0X0F6B
USTAT            EQU 0X0F6C
UCON             EQU 0X0F6D
UADDR            EQU 0X0F6E
UCFG             EQU 0X0F6F
UEP0             EQU 0X0F70
UEP1             EQU 0X0F71
UEP2             EQU 0X0F72
UEP3             EQU 0X0F73
UEP4             EQU 0X0F74
UEP5             EQU 0X0F75
UEP6             EQU 0X0F76
UEP7             EQU 0X0F77
UEP8             EQU 0X0F78
UEP9             EQU 0X0F79
UEP10            EQU 0X0F7A
UEP11            EQU 0X0F7B
UEP12            EQU 0X0F7C
UEP13            EQU 0X0F7D
UEP14            EQU 0X0F7E
UEP15            EQU 0X0F7F
LATA             EQU 0X0F89
LATB             EQU 0X0F8A
LATC             EQU 0X0F8B
LATD             EQU 0X0F8C
LATE             EQU 0X0F8D
DDRA             EQU 0X0F92
TRISA            EQU 0X0F92
DDRB             EQU 0X0F93
TRISB            EQU 0X0F93
DDRC             EQU 0X0F94
TRISC            EQU 0X0F94
DDRD             EQU 0X0F95
TRISD            EQU 0X0F95
DDRE             EQU 0X0F96
TRISE            EQU 0X0F96
OSCTUNE          EQU 0X0F9B
PIE1             EQU 0X0F9D
PIR1             EQU 0X0F9E
IPR1             EQU 0X0F9F
PIE2             EQU 0X0FA0
PIR2             EQU 0X0FA1
IPR2             EQU 0X0FA2
EECON1           EQU 0X0FA6
EECON2           EQU 0X0FA7
EEDATA           EQU 0X0FA8
EEADR            EQU 0X0FA9
RCSTA            EQU 0X0FAB
TXSTA            EQU 0X0FAC
TXREG            EQU 0X0FAD
RCREG            EQU 0X0FAE
SPBRG            EQU 0X0FAF
SPBRGH           EQU 0X0FB0
T3CON            EQU 0X0FB1
TMR3L            EQU 0X0FB2
TMR3LH           EQU 0X0FB3
TMR3H            EQU 0X0FB3
CMCON            EQU 0X0FB4
CVRCON           EQU 0X0FB5
CCP1AS           EQU 0X0FB6
ECCP1AS          EQU 0X0FB6
CCP1DEL          EQU 0X0FB7
ECCP1DEL         EQU 0X0FB7
BAUDCON          EQU 0X0FB8
CCP2CON          EQU 0X0FBA
CCPR2            EQU 0X0FBB
CCPR2L           EQU 0X0FBB
CCPR2LH          EQU 0X0FBC
CCPR2H           EQU 0X0FBC
CCP1CON          EQU 0X0FBD
ECCP1CON         EQU 0X0FBD
CCPR1            EQU 0X0FBE
CCPR1L           EQU 0X0FBE
CCPR1LH          EQU 0X0FBF
CCPR1H           EQU 0X0FBF
ADCON2           EQU 0X0FC0
ADCON1           EQU 0X0FC1
ADCON0           EQU 0X0FC2
ADRES            EQU 0X0FC3
ADRESL           EQU 0X0FC3
ADRESLH          EQU 0X0FC4
ADRESH           EQU 0X0FC4
SSPCON2          EQU 0X0FC5
SSPCON1          EQU 0X0FC6
SSPSTAT          EQU 0X0FC7
SSPADD           EQU 0X0FC8
SSPBUF           EQU 0X0FC9
T2CON            EQU 0X0FCA
PR2              EQU 0X0FCB
TMR2             EQU 0X0FCC
T1CON            EQU 0X0FCD
TMR1L            EQU 0X0FCE
TMR1LH           EQU 0X0FCF
TMR1H            EQU 0X0FCF
RCON             EQU 0X0FD0
WDTCON           EQU 0X0FD1
HLVDCON          EQU 0X0FD2
LVDCON           EQU 0X0FD2
OSCCON           EQU 0X0FD3
T0CON            EQU 0X0FD5
TMR0L            EQU 0X0FD6
TMR0LH           EQU 0X0FD7
TMR0H            EQU 0X0FD7
STATUS           EQU 0X0FD8
FSR2L            EQU 0X0FD9
FSR2LH           EQU 0X0FDA
FSR2H            EQU 0X0FDA
PLUSW2           EQU 0X0FDB
PREINC2          EQU 0X0FDC
POSTDEC2         EQU 0X0FDD
POSTINC2         EQU 0X0FDE
INDF2            EQU 0X0FDF
BSR              EQU 0X0FE0
FSR1L            EQU 0X0FE1
FSR1LH           EQU 0X0FE2
FSR1H            EQU 0X0FE2
PLUSW1           EQU 0X0FE3
PREINC1          EQU 0X0FE4
POSTDEC1         EQU 0X0FE5
POSTINC1         EQU 0X0FE6
INDF1            EQU 0X0FE7
WREG             EQU 0X0FE8
FSR0L            EQU 0X0FE9
FSR0LH           EQU 0X0FEA
FSR0H            EQU 0X0FEA
PLUSW0           EQU 0X0FEB
PREINC0          EQU 0X0FEC
POSTDEC0         EQU 0X0FED
POSTINC0         EQU 0X0FEE
INDF0            EQU 0X0FEF
INTCON3          EQU 0X0FF0
INTCON2          EQU 0X0FF1
INTCON           EQU 0X0FF2
PROD             EQU 0X0FF3
PRODL            EQU 0X0FF3
PRODLH           EQU 0X0FF4
PRODH            EQU 0X0FF4
TABLAT           EQU 0X0FF5
TBLPTR           EQU 0X0FF6
TBLPTRL          EQU 0X0FF6
TBLPTRLH         EQU 0X0FF7
TBLPTRH          EQU 0X0FF7
TBLPTRU          EQU 0X0FF8
PC               EQU 0X0FF9
PCL              EQU 0X0FF9
PCLATH           EQU 0X0FFA
PCLATU           EQU 0X0FFB
STKPTR           EQU 0X0FFC
TOS              EQU 0X0FFD
TOSL             EQU 0X0FFD
TOSLH            EQU 0X0FFE
TOSH             EQU 0X0FFE
TOSU             EQU 0X0FFF
; SYSTEM PORTS...
PORTE            EQU 0X0F84
PORTD            EQU 0X0F83
PORTC            EQU 0X0F82
PORTB            EQU 0X0F81
PORTA            EQU 0X0F80
; SPPCFG
WS0 = 0
WS1 = 1
WS2 = 2
WS3 = 3
CLK1EN = 4
CSEN = 5
CLKCFG0 = 6
CLKCFG1 = 7
; SPPEPS
ADDR0 = 0
ADDR1 = 1
ADDR2 = 2
ADDR3 = 3
SPPBUSY = 4
WRSPP = 6
RDSPP = 7
; SPPCON
SPPEN = 0
SPPOWN = 1
; UFRML
FRM0 = 0
FRM1 = 1
FRM2 = 2
FRM3 = 3
FRM4 = 4
FRM5 = 5
FRM6 = 6
FRM7 = 7
; UFRMH
FRM8 = 0
FRM9 = 1
FRM10 = 2
; UIR
URSTIF = 0
UERRIF = 1
ACTVIF = 2
TRNIF = 3
IDLEIF = 4
STALLIF = 5
SOFIF = 6
; UIE
URSTIE = 0
UERRIE = 1
ACTVIE = 2
TRNIE = 3
IDLEIE = 4
STALLIE = 5
SOFIE = 6
; UEIR
PIDEF = 0
CRC5EF = 1
CRC16EF = 2
DFN8EF = 3
BTOEF = 4
BTSEF = 7
; UEIE
PIDEE = 0
CRC5EE = 1
CRC16EE = 2
DFN8EE = 3
BTOEE = 4
BTSEE = 7
; USTAT
PPBI = 1
DIR = 2
ENDP0 = 3
ENDP1 = 4
ENDP2 = 5
ENDP3 = 6
; UCON
SUSPND = 1
RESUME = 2
USBEN = 3
PKTDIS = 4
SE0 = 5
PPBRST = 6
; UADDR
ADDR0 = 0
ADDR1 = 1
ADDR2 = 2
ADDR3 = 3
ADDR4 = 4
ADDR5 = 5
ADDR6 = 6
; UCFG
PPB0 = 0
PPB1 = 1
FSEN = 2
UTRDIS = 3
UPUEN = 4
UOEMON = 6
UTEYE = 7
; UEP0
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP1
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP2
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP3
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP4
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP5
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP6
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP7
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP8
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP9
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP10
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP11
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP12
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP13
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP14
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; UEP15
EPSTALL = 0
EPINEN = 1
EPOUTEN = 2
EPCONDIS = 3
EPHSHK = 4
; PORTA
RA0 = 0
RA1 = 1
RA2 = 2
RA3 = 3
RA4 = 4
RA5 = 5
RA6 = 6
AN0 = 0
AN1 = 1
AN2 = 2
AN3 = 3
T0CKI = 4
AN4 = 5
OSC2 = 6
VREFM = 2
VREFP = 3
LVDIN = 5
HLVDIN = 5
; PORTB
RB0 = 0
RB1 = 1
RB2 = 2
RB3 = 3
RB4 = 4
RB5 = 5
RB6 = 6
RB7 = 7
INT0 = 0
INT1 = 1
INT2 = 2
PGM = 5
PGC = 6
PGD = 7
; PORTC
RC0 = 0
RC1 = 1
RC2 = 2
RC4 = 4
RC5 = 5
RC6 = 6
RC7 = 7
T1OSO = 0
T1OSI = 1
CCP1 = 2
TX = 6
RX = 7
T13CKI = 0
P1A = 2
CK = 6
; DT = 7
; PORTD
RD0 = 0
RD1 = 1
RD2 = 2
RD3 = 3
RD4 = 4
RD5 = 5
RD6 = 6
RD7 = 7
SPP0 = 0
SPP1 = 1
SPP2 = 2
SPP3 = 3
SPP4 = 4
SPP5 = 5
SPP6 = 6
SPP7 = 7
; PORTE
RE0 = 0
RE1 = 1
RE2 = 2
RE3 = 3
RDPU = 7
CK1SPP = 0
CK2SPP = 1
OESPP = 2
; LATA
LATA0 = 0
LATA1 = 1
LATA2 = 2
LATA3 = 3
LATA4 = 4
LATA5 = 5
LATA6 = 6
; LATB
LATB0 = 0
LATB1 = 1
LATB2 = 2
LATB3 = 3
LATB4 = 4
LATB5 = 5
LATB6 = 6
LATB7 = 7
; LATC
LATC0 = 0
LATC1 = 1
LATC2 = 2
LATC6 = 6
LATC7 = 7
; LATD
LATD0 = 0
LATD1 = 1
LATD2 = 2
LATD3 = 3
LATD4 = 4
LATD5 = 5
LATD6 = 6
LATD7 = 7
; LATE
LATE0 = 0
LATE1 = 1
LATE2 = 2
; DDRA
RA0 = 0
RA1 = 1
RA2 = 2
RA3 = 3
RA4 = 4
RA5 = 5
RA6 = 6
; TRISA
TRISA0 = 0
TRISA1 = 1
TRISA2 = 2
TRISA3 = 3
TRISA4 = 4
TRISA5 = 5
TRISA6 = 6
; DDRB
RB0 = 0
RB1 = 1
RB2 = 2
RB3 = 3
RB4 = 4
RB5 = 5
RB6 = 6
RB7 = 7
; TRISB
TRISB0 = 0
TRISB1 = 1
TRISB2 = 2
TRISB3 = 3
TRISB4 = 4
TRISB5 = 5
TRISB6 = 6
TRISB7 = 7
; DDRC
RC0 = 0
RC1 = 1
RC2 = 2
RC6 = 6
RC7 = 7
; TRISC
TRISC0 = 0
TRISC1 = 1
TRISC2 = 2
TRISC6 = 6
TRISC7 = 7
; DDRD
RD0 = 0
RD1 = 1
RD2 = 2
RD3 = 3
RD4 = 4
RD5 = 5
RD6 = 6
RD7 = 7
; TRISD
TRISD0 = 0
TRISD1 = 1
TRISD2 = 2
TRISD3 = 3
TRISD4 = 4
TRISD5 = 5
TRISD6 = 6
TRISD7 = 7
; DDRE
RE0 = 0
RE1 = 1
RE2 = 2
; TRISE
TRISE0 = 0
TRISE1 = 1
TRISE2 = 2
; OSCTUNE
TUN0 = 0
TUN1 = 1
TUN2 = 2
TUN3 = 3
TUN4 = 4
INTSRC = 7
; PIE1
TMR1IE = 0
TMR2IE = 1
CCP1IE = 2
SSPIE = 3
TXIE = 4
RCIE = 5
ADIE = 6
SPPIE = 7
; PIR1
TMR1IF = 0
TMR2IF = 1
CCP1IF = 2
SSPIF = 3
TXIF = 4
RCIF = 5
ADIF = 6
SPPIF = 7
; IPR1
TMR1IP = 0
TMR2IP = 1
CCP1IP = 2
SSPIP = 3
TXIP = 4
RCIP = 5
ADIP = 6
SPPIP = 7
; PIE2
CCP2IE = 0
TMR3IE = 1
LVDIE = 2
BCLIE = 3
EEIE = 4
USBIE = 5
CMIE = 6
OSCFIE = 7
HLVDIE = 2
; PIR2
CCP2IF = 0
TMR3IF = 1
LVDIF = 2
BCLIF = 3
EEIF = 4
USBIF = 5
CMIF = 6
OSCFIF = 7
HLVDIF = 2
; IPR2
CCP2IP = 0
TMR3IP = 1
LVDIP = 2
BCLIP = 3
EEIP = 4
USBIP = 5
CMIP = 6
OSCFIP = 7
HLVDIP = 2
; EECON1
RD = 0
WR = 1
WREN = 2
WRERR = 3
FREE = 4
CFGS = 6
EEPGD = 7
; RCSTA
RX9D = 0
OERR = 1
FERR = 2
ADDEN = 3
CREN = 4
SREN = 5
RX9 = 6
SPEN = 7
ADEN = 3
; TXSTA
TX9D = 0
TRMT = 1
BRGH = 2
SENDB = 3
SYNC = 4
TXEN = 5
TX9 = 6
CSRC = 7
; T3CON
TMR3ON = 0
TMR3CS = 1
T3SYNC = 2
T3CCP1 = 3
T3CKPS0 = 4
T3CKPS1 = 5
T3CCP2 = 6
RD16 = 7
T3NSYNC = 2
NOT_T3SYNC = 2
; CMCON
CM0 = 0
CM1 = 1
CM2 = 2
CIS = 3
C1INV = 4
C2INV = 5
C1OUT = 6
C2OUT = 7
; CVRCON
CVR0 = 0
CVR1 = 1
CVR2 = 2
CVR3 = 3
CVREF = 4
CVRR = 5
CVROE = 6
CVREN = 7
CVRSS = 4
; CCP1AS
PSSBD0 = 0
PSSBD1 = 1
PSSAC0 = 2
PSSAC1 = 3
ECCPAS0 = 4
ECCPAS1 = 5
ECCPAS2 = 6
ECCPASE = 7
; ECCP1AS
PSSBD0 = 0
PSSBD1 = 1
PSSAC0 = 2
PSSAC1 = 3
ECCPAS0 = 4
ECCPAS1 = 5
ECCPAS2 = 6
ECCPASE = 7
; CCP1DEL
PDC0 = 0
PDC1 = 1
PDC2 = 2
PDC3 = 3
PDC4 = 4
PDC5 = 5
PDC6 = 6
PRSEN = 7
; ECCP1DEL
PDC0 = 0
PDC1 = 1
PDC2 = 2
PDC3 = 3
PDC4 = 4
PDC5 = 5
PDC6 = 6
PRSEN = 7
; BAUDCON
ABDEN = 0
WUE = 1
BRG16 = 3
SCKP = 4
RCIDL = 6
ABDOVF = 7
RCMT = 6
; CCP2CON
CCP2M0 = 0
CCP2M1 = 1
CCP2M2 = 2
CCP2M3 = 3
DC2B0 = 4
DC2B1 = 5
; CCP1CON
CCP1M0 = 0
CCP1M1 = 1
CCP1M2 = 2
CCP1M3 = 3
DC1B0 = 4
DC1B1 = 5
P1M0 = 6
P1M1 = 7
; ECCP1CON
CCP1M0 = 0
CCP1M1 = 1
CCP1M2 = 2
CCP1M3 = 3
DC1B0 = 4
DC1B1 = 5
P1M0 = 6
P1M1 = 7
; ADCON2
ADCS0 = 0
ADCS1 = 1
ADCS2 = 2
ACQT0 = 3
ACQT1 = 4
ACQT2 = 5
ADFM = 7
; ADCON1
PCFG0 = 0
PCFG1 = 1
PCFG2 = 2
PCFG3 = 3
VCFG0 = 4
VCFG1 = 5
; ADCON0
ADON = 0
GO_DONE = 1
CHS0 = 2
CHS1 = 3
CHS2 = 4
CHS3 = 5
DONE = 1
GO = 1
NOT_DONE = 1
; SSPCON2
SEN = 0
RSEN = 1
PEN = 2
RCEN = 3
ACKEN = 4
ACKDT = 5
ACKSTAT = 6
GCEN = 7
; SSPCON1
SSPM0 = 0
SSPM1 = 1
SSPM2 = 2
SSPM3 = 3
CKP = 4
SSPEN = 5
SSPOV = 6
WCOL = 7
; SSPSTAT
BF = 0
UA = 1
R_W = 2
S = 3
P = 4
D_A = 5
CKE = 6
SMP = 7
I2C_READ = 2
I2C_START = 3
I2C_STOP = 4
I2C_DAT = 5
NOT_W = 2
NOT_A = 5
NOT_WRITE = 2
NOT_ADDRESS = 5
READ_WRITE = 2
DATA_ADDRESS = 5
R = 2
D = 5
; T2CON
T2CKPS0 = 0
T2CKPS1 = 1
TMR2ON = 2
T2OUTPS0 = 3
T2OUTPS1 = 4
T2OUTPS2 = 5
T2OUTPS3 = 6
; T1CON
TMR1ON = 0
TMR1CS = 1
T1SYNC = 2
T1OSCEN = 3
T1CKPS0 = 4
T1CKPS1 = 5
T1RUN = 6
RD16 = 7
NOT_T1SYNC = 2
; RCON
NOT_BOR = 0
NOT_POR = 1
NOT_PD = 2
NOT_TO = 3
NOT_RI = 4
SBOREN = 6
NOT_IPEN = 7
BOR = 0
POR = 1
PD = 2
TO = 3
RI = 4
IPEN = 7
; WDTCON
SWDTEN = 0
SWDTE = 0
; HLVDCON
LVDL0 = 0
LVDL1 = 1
LVDL2 = 2
LVDL3 = 3
LVDEN = 4
IRVST = 5
LVV0 = 0
LVV1 = 1
LVV2 = 2
LVV3 = 3
BGST = 5
HLVDL0 = 0
HLVDL1 = 1
HLVDL2 = 2
HLVDL3 = 3
HLVDEN = 4
VDIRMAG = 7
IVRST = 5
; LVDCON
LVDL0 = 0
LVDL1 = 1
LVDL2 = 2
LVDL3 = 3
LVDEN = 4
IRVST = 5
LVV0 = 0
LVV1 = 1
LVV2 = 2
LVV3 = 3
BGST = 5
HLVDL0 = 0
HLVDL1 = 1
HLVDL2 = 2
HLVDL3 = 3
HLVDEN = 4
VDIRMAG = 7
IVRST = 5
; OSCCON
SCS0 = 0
SCS1 = 1
IOFS = 2
OSTS = 3
IRCF0 = 4
IRCF1 = 5
IRCF2 = 6
IDLEN = 7
FLTS = 2
; T0CON
T0PS0 = 0
T0PS1 = 1
T0PS2 = 2
PSA = 3
T0SE = 4
T0CS = 5
T08BIT = 6
TMR0ON = 7
; STATUS
C = 0
DC = 1
Z = 2
OV = 3
N = 4
; INTCON3
INT1IF = 0
INT2IF = 1
INT1IE = 3
INT2IE = 4
INT1IP = 6
INT2IP = 7
INT1F = 0
INT2F = 1
INT1E = 3
INT2E = 4
INT1P = 6
INT2P = 7
; INTCON2
RBIP = 0
TMR0IP = 2
INTEDG2 = 4
INTEDG1 = 5
INTEDG0 = 6
NOT_RBPU = 7
T0IP = 2
RBPU = 7
; INTCON
RBIF = 0
INT0IF = 1
TMR0IF = 2
RBIE = 3
INT0IE = 4
TMR0IE = 5
PEIE = 6
GIE = 7
INT0F = 1
T0IF = 2
INT0E = 4
T0IE = 5
GIEL = 6
GIEH = 7
; STKPTR
STKPTR0 = 0
STKPTR1 = 1
STKPTR2 = 2
STKPTR3 = 3
STKPTR4 = 4
STKUNF = 6
STKFUL = 7
 #DEFINE W 0
 #DEFINE F 1
 #DEFINE A 0
 #DEFINE _CLOCK 48000000
 #DEFINE CLRW CLRF 4072,0
 #DEFINE NEGW NEGF 4072,0
 #DEFINE SKPC BTFSS 4056,0,0
 #DEFINE SKPNC BTFSC 4056,0,0
 #DEFINE CLRC BCF 4056,0,0
 #DEFINE SETC BSF 4056,0,0
 #DEFINE SKPZ BTFSS 4056,2,0
 #DEFINE SKPNZ BTFSC 4056,2,0
 #DEFINE CLRZ BCF 4056,2,0
 #DEFINE SETZ BSF 4056,2,0
SB_SV0 EQU 0
SB_SV0H EQU 1
SB_SV0HH EQU 2
SB_SV0HHH EQU 3
SB_SV1 EQU 4
SB_SV1H EQU 5
SB_SV2 EQU 6
SB_SV2H EQU 7
SB_SV2HH EQU 8
SB_SV2HHH EQU 9
SB_SV3 EQU 10
SB_SV3H EQU 11
SB_SV3HH EQU 12
SB_SV3HHH EQU 13
SB_SV4 EQU 14
SB_SV4H EQU 15
SB_SV5 EQU 16
SB_SV5H EQU 17
SB_SV5HH EQU 18
SB_SV5HHH EQU 19
SB_SV6 EQU 20
SB_SV6H EQU 21
SB_SV6HH EQU 22
SB_SV6HHH EQU 23
SB_SV7 EQU 24
A0 EQU 4073
A0H EQU 4074
A1 EQU 4065
A1H EQU 4066
A2 EQU 4057
A2H EQU 4058
TBPTR EQU 4086
TBPTRH EQU 4087
_FSR0L#M0_U16 EQU 4073
_FSR0L#M0_U16H EQU 4074
F0_U08 EQU 25
F0_U32 EQU 25
F0_U32H EQU 26
F0_U32HH EQU 27
F0_U32HHH EQU 28
F1_U32 EQU 26
F1_U32H EQU 27
F1_U32HH EQU 28
F1_U32HHH EQU 29
F1_U08 EQU 26
F2_U08 EQU 27
F2_S08 EQU 27
F3_U16 EQU 28
F3_U16H EQU 29
F3_U08 EQU 28
F4_U08 EQU 29
F5_U08 EQU 30
F6_U08 EQU 31
F7_U08 EQU 32
F8_U08 EQU 33
F9_U08 EQU 34
F9_U01 EQU 34
F10_U08 EQU 35
F11_U32 EQU 36
F11_U32H EQU 37
F11_U32HH EQU 38
F11_U32HHH EQU 39
F11_ADR EQU 36
F11_ADRH EQU 37
F15_U08 EQU 40
F16_U08 EQU 41
F17_U136 EQU 42
F17_U136H EQU 43
F38_U32 EQU 63
F38_U32H EQU 64
F38_U32HH EQU 65
F38_U32HHH EQU 66
F42_U08 EQU 67
F42_U48 EQU 67
F42_U48H EQU 68
F43_U08 EQU 68
F44_U08 EQU 69
F45_U08 EQU 70
F46_U08 EQU 71
F47_U08 EQU 72
F54_ADR EQU 79
F54_ADRH EQU 80
F56_ADR EQU 81
F56_ADRH EQU 82
F58_U08 EQU 83
F59_U08 EQU 84
F60_U08 EQU 85
W0_U08 EQU 98
W1_ADR EQU 99
W1_ADRH EQU 100
W2_U08 EQU 100
W3_U32 EQU 101
W3_U32H EQU 102
W3_U32HH EQU 103
W3_U32HHH EQU 104
W5_U08 EQU 103
W7_U32 EQU 105
W7_U32H EQU 106
W7_U32HH EQU 107
W7_U32HHH EQU 108
M0_U01 EQU 109
M1_U08 EQU 110
M2_U08 EQU 111
M3_S08 EQU 112
M4_S08 EQU 113
M5_U08 EQU 114
M6_U08 EQU 115
M7_U08 EQU 116
M8_U08 EQU 117
M9_U08 EQU 118
M10_U08 EQU 119
M11_U08 EQU 120
M12_U08 EQU 121
M13_U08 EQU 122
M14_U16 EQU 123
M14_U16H EQU 124
M20_U32 EQU 129
M20_U32H EQU 130
M20_U32HH EQU 131
M20_U32HHH EQU 132
M24_U32 EQU 133
M24_U32H EQU 134
M24_U32HH EQU 135
M24_U32HHH EQU 136
M28_U08 EQU 137
M29_U08 EQU 138
M30_U32 EQU 139
M30_U32H EQU 140
M30_U32HH EQU 141
M30_U32HHH EQU 142
M34_U08 EQU 143
M35_U32 EQU 144
M35_U32H EQU 145
M35_U32HH EQU 146
M35_U32HHH EQU 147
        ORG 0XF00000
        DB 0,0,0,0
        ORG 0X002000
        GOTO SBCDSTD
        ORG 0X002008
        GOTO ISR_ONCHANGEPORTB_0
        ORG 0X002018
        GOTO ISR_ONTIMER_0
SBDLYMS
        CLRF 5,0
SBDLYMS16
        MOVWF 4,0
        MOVLW 255
        ADDWF 4,1,0
        BTFSS 4056,0,0
        ADDWF 5,1,0
        NOP
        BTFSS 4056,0,0
        RETURN 0
        MOVLW 3
        MOVWF 1,0
        MOVLW 231
        RCALL SBDLYUS16
        BRA $ - 22
SBDLYUS
        CLRF 1,0
SBDLYUS16
        ADDLW 253
        MOVWF 0,0
        MOVLW 255
        BRA $ + 2
        BRA $ + 4
        ADDWF 0,1,0
        NOP
        BRA $ + 2
        BRA $ + 2
        BTFSS 4056,0,0
        ADDWF 1,1,0
        BTFSS 4056,0,0
        RETURN 0
        BRA $ - 16
SB_DIV_U_32X32
        CLRF 16,0
        CLRF 17,0
        CLRF 18,0
        CLRF 19,0
        CLRF 10,0
        CLRF 11,0
        CLRF 12,0
        CLRF 13,0
        MOVF 9,0,0
        IORWF 8,0,0
        IORWF 7,0,0
        IORWF 6,0,0
        BZ DIV_U_32X32_EXIT
        MOVLW 32
        MOVWF 4083
DIV_U_32X32_LOOP
        BCF 4056,0,0
        RLCF 0,1,0
        RLCF 1,1,0
        RLCF 2,1,0
        RLCF 3,1,0
        RLCF 10,1,0
        RLCF 11,1,0
        RLCF 12,1,0
        RLCF 13,1,0
        MOVF 9,0,0
        SUBWF 13,0,0
        BNZ $ + 18
        MOVF 8,0,0
        SUBWF 12,0,0
        BNZ $ + 12
        MOVF 7,0,0
        SUBWF 11,0,0
        BNZ $ + 6
        MOVF 6,0,0
        SUBWF 10,0,0
        BNC DIV_U_32X32_SKIP
        MOVF 6,0,0
        SUBWF 10,1,0
        MOVF 7,0,0
        BTFSS 4056,0,0
        INCFSZ 7,0,0
        SUBWF 11,1,0
        MOVF 8,0,0
        BTFSS 4056,0,0
        INCFSZ 8,0,0
        SUBWF 12,1,0
        MOVF 9,0,0
        BTFSS 4056,0,0
        INCFSZ 9,0,0
        SUBWF 13,1,0
        BSF 4056,0,0
DIV_U_32X32_SKIP
        RLCF 16,1,0
        RLCF 17,1,0
        RLCF 18,1,0
        RLCF 19,1,0
        DECFSZ 4083,1,0
        BRA DIV_U_32X32_LOOP
DIV_U_32X32_EXIT
        RETURN 0
SB_MULT32X32
        MOVLW 32
        MOVWF 16,0
        CLRF 10,0
        CLRF 11,0
        CLRF 12,0
        CLRF 13,0
SB_MULT32X32LP
        BCF 4056,0,0
        BTFSS 0,0,0
        BRA SB_MULT32X32SK
        MOVF 6,0,0
        ADDWF 10,1,0
        MOVF 7,0,0
        BTFSC 4056,0,0
        INCFSZ 7,0,0
        ADDWF 11,1,0
        MOVF 8,0,0
        BTFSC 4056,0,0
        INCFSZ 8,0,0
        ADDWF 12,1,0
        MOVF 9,0,0
        BTFSC 4056,0,0
        INCFSZ 9,0,0
        ADDWF 13,1,0
SB_MULT32X32SK
        RRCF 13,1,0
        RRCF 12,1,0
        RRCF 11,1,0
        RRCF 10,1,0
        RRCF 3,1,0
        RRCF 2,1,0
        RRCF 1,1,0
        RRCF 0,1,0
        DECFSZ 16,1,0
        BRA SB_MULT32X32LP
        RETURN 0
SBCDSTD
        GOTO MAIN
PROC_DEC32TOSTRFORMAT_0
?I000000_F002_000201_P000072 ; L#MK FIRSTPASS = TRUE
        BSF F9_U01,0,0
?I000001_F002_000202_P000072 ; L#MK IF PPAD > PMAX THEN
; CMPLE_BT_BT_LBL F5_U08,F8_U08,ENDIF_0
        MOVF F5_U08,0,0
        CPFSLT F8_U08
        BRA ENDIF_0
?I000002_F002_000203_P000072 ; L#MK PPAD = PMAX
        MOVFF F8_U08,F5_U08
ENDIF_0
?I000003_F002_000206_P000072 ; L#MK INC(FTEXTADDRESS, PPAD)
        MOVF F5_U08,0,0
        ADDWF _FSR0L#M0_U16,1,0
        MOVLW 0
        ADDWFC _FSR0L#M0_U16H,1,0
?I000004_F002_000207_P000072 ; L#MK TEXTPTR = NULL
        CLRF POSTDEC0,0
?I000005_F002_000208_P000072 ; L#MK WHILE PPAD > 0
WHILE_0
; CMPLE_BT_NM_LBL F5_U08,0,FALSE_0
        MOVF F5_U08,1,0
        BTFSC STATUS,2,0
        BRA FALSE_0
?I000006_F002_000209_P000072 ; L#MK IF PVALUE = 0 THEN
; CMPNE_DW_NM_LBL F0_U32,0,FALSE_1
; CMPNE_NM_DW_LBL 0,F0_U32,FALSE_1
        MOVF F0_U32HHH,0,0
        IORWF F0_U32HH,0,0
        IORWF F0_U32H,0,0
        IORWF F0_U32,0,0
        BNZ FALSE_1
?I000007_F002_000210_P000072 ; L#MK IF FIRSTPASS THEN
; CMPNE_BI_NM_LBL F9_U01,0,1,ENDIF_2
; CMPNE_NM_BI_LBL 1,F9_U01,0,ENDIF_2
        BTFSS F9_U01,0,0
        BRA ENDIF_2
?I000008_F002_000211_P000072 ; L#MK PSIGNCHAR = "0"
        MOVLW 48
        MOVWF F7_U08,0
ENDIF_2
?I000009_F002_000213_P000072 ; L#MK TEXTPTR = PSIGNCHAR
        MOVFF F7_U08,POSTDEC0
?I000010_F002_000214_P000072 ; L#MK PSIGNCHAR = PPADCHAR
        MOVFF F6_U08,F7_U08
        BRA ENDIF_1
FALSE_1
?I000011_F002_000216_P000072 ; L#MK NUMBER = PVALUE MOD PBASE
        MOVFF F0_U32HHH,SB_SV0HHH
        MOVFF F0_U32HH,SB_SV0HH
        MOVFF F0_U32H,SB_SV0H
        MOVFF F0_U32,SB_SV0
        CLRF SB_SV2HHH,0
        CLRF SB_SV2HH,0
        CLRF SB_SV2H,0
        MOVFF F4_U08,SB_SV2
        RCALL SB_DIV_U_32X32
        MOVFF SB_SV3,F10_U08
?I000012_F002_000217_P000072 ; L#MK IF NUMBER > 9 THEN
; CMPLE_BT_NM_LBL F10_U08,9,ENDIF_3
; CMPGE_NM_BT_LBL 9,F10_U08,ENDIF_3
        MOVLW 9
        CPFSGT F10_U08
        BRA ENDIF_3
?I000013_F002_000218_P000072 ; L#MK INC(NUMBER, 7)
        MOVLW 7
        ADDWF F10_U08,1,0
ENDIF_3
?I000014_F002_000220_P000072 ; L#MK TEXTPTR = NUMBER + 48
        MOVLW 48
        ADDWF F10_U08,0,0
        MOVWF POSTDEC0,0
?I000015_F002_000221_P000072 ; L#MK PVALUE = PVALUE / PBASE
        MOVFF F0_U32HHH,SB_SV0HHH
        MOVFF F0_U32HH,SB_SV0HH
        MOVFF F0_U32H,SB_SV0H
        MOVFF F0_U32,SB_SV0
        CLRF SB_SV2HHH,0
        CLRF SB_SV2HH,0
        CLRF SB_SV2H,0
        MOVFF F4_U08,SB_SV2
        RCALL SB_DIV_U_32X32
        MOVFF SB_SV5HHH,F0_U32HHH
        MOVFF SB_SV5HH,F0_U32HH
        MOVFF SB_SV5H,F0_U32H
        MOVFF SB_SV5,F0_U32
ENDIF_1
?I000016_F002_000223_P000072 ; L#MK DEC(PPAD)
        DECF F5_U08,1,0
?I000017_F002_000224_P000072 ; L#MK FIRSTPASS = FALSE
        BCF F9_U01,0,0
        BRA WHILE_0
FALSE_0
?I000018_F002_000226_P000072 ; L#MK END SUB
        RETURN 0
PROC_OL_10_DECTOSTR_0
?I000019_F002_000520_P000090 ; L#MK FTEXTADDRESS = @RESULT
        LFSR 0,F17_U136
?I000020_F002_000521_P000090 ; L#MK DEC32TOSTRFORMAT(PVALUE, 10, PPAD, PPADCHAR, PPADCHAR)
        MOVLW 16
        MOVWF F8_U08,0
        MOVFF F11_U32HHH,F0_U32HHH
        MOVFF F11_U32HH,F0_U32HH
        MOVFF F11_U32H,F0_U32H
        MOVFF F11_U32,F0_U32
        MOVLW 10
        MOVWF F4_U08,0
        MOVFF F15_U08,F5_U08
        MOVFF F16_U08,F6_U08
        MOVFF F16_U08,F7_U08
        BRA PROC_DEC32TOSTRFORMAT_0
PROC_READBYTE_0
?I000022_F005_000065_P000114 ; L#MK EECON1 = $00
        CLRF EECON1,0
?I000023_F005_000066_P000114 ; L#MK RD = TRUE
        BSF EECON1,0,0
?I000024_F005_000067_P000114 ; L#MK RESULT = EEDATA
        MOVFF EEDATA,F0_U08
?I000025_F005_000068_P000114 ; L#MK BACKTOFLASH
        MOVLW 128
        MOVWF EECON1,0
?I000026_F005_000069_P000114 ; L#MK INC(ADDRESS)
        INCF EEADR,1,0
?I000027_F005_000070_P000114 ; L#MK CLRWDT
?I000028_F005_000071_P000114 ; L#MK END FUNCTION
        RETURN 0
PROC_READLONGWORD_0
?I000029_F005_000098_P000117 ; L#MK RESULT.BYTES(0) = READBYTE(PADDRESS)
        RCALL PROC_READBYTE_0
        MOVFF F0_U08,F1_U08
?I000030_F005_000099_P000117 ; L#MK RESULT.BYTES(1) = READBYTE(PADDRESS)
        RCALL PROC_READBYTE_0
        MOVFF F0_U08,F2_U08
?I000031_F005_000100_P000117 ; L#MK RESULT.BYTES(2) = READBYTE(PADDRESS)
        RCALL PROC_READBYTE_0
        MOVFF F0_U08,F3_U08
?I000032_F005_000101_P000117 ; L#MK RESULT.BYTES(3) = READBYTE(PADDRESS)
        RCALL PROC_READBYTE_0
        MOVFF F0_U08,F4_U08
?I000033_F005_000102_P000117 ; L#MK END FUNCTION
        RETURN 0
PROC_WRITEBYTE_0
?I000034_F005_000128_P000119 ; L#MK EECON1 = $00
        CLRF EECON1,0
?I000035_F005_000129_P000119 ; L#MK WREN = TRUE
        BSF EECON1,2,0
?I000036_F005_000132_P000119 ; L#MK EECON2 = $55
        MOVLW 85
        MOVWF EECON2,0
?I000037_F005_000133_P000119 ; L#MK EECON2 = $AA
        MOVLW 170
        MOVWF EECON2,0
?I000038_F005_000134_P000119 ; L#MK WR = TRUE
        BSF EECON1,1,0
REPEAT_0
?I000039_F005_000138_P000119 ; L#MK CLRWDT
?I000040_F005_000139_P000119 ; L#MK UNTIL NOT WR
; CMPEQ_BI_NM_LBL EECON1,1,1,REPEAT_0
; CMPEQ_NM_BI_LBL 1,EECON1,1,REPEAT_0
        BTFSC EECON1,1,0
        BRA REPEAT_0
?I000041_F005_000140_P000119 ; L#MK WREN = FALSE  // DISABLE WRITES
        BCF EECON1,2,0
?I000042_F005_000141_P000119 ; L#MK BACKTOFLASH
        MOVLW 128
        MOVWF EECON1,0
?I000043_F005_000142_P000119 ; L#MK INC(ADDRESS)
        INCF EEADR,1,0
?I000044_F005_000143_P000119 ; L#MK END SUB
        RETURN 0
PROC_WRITELONGWORD_0
?I000045_F005_000170_P000122 ; L#MK WRITEBYTE(PADDRESS,PVALUE.BYTES(0))
        MOVFF F0_U08,EEDATA
        RCALL PROC_WRITEBYTE_0
?I000046_F005_000171_P000122 ; L#MK WRITEBYTE(PADDRESS,PVALUE.BYTES(1))
        MOVFF F1_U08,EEDATA
        RCALL PROC_WRITEBYTE_0
?I000047_F005_000172_P000122 ; L#MK WRITEBYTE(PADDRESS,PVALUE.BYTES(2))
        MOVFF F2_U08,EEDATA
        RCALL PROC_WRITEBYTE_0
?I000048_F005_000173_P000122 ; L#MK WRITEBYTE(PADDRESS,PVALUE.BYTES(3))
        MOVFF F3_U08,EEDATA
        BRA PROC_WRITEBYTE_0
PROC_LED7SEG_DECODE_ASCII_0
?I000050_F000_000247_P000144 ; L#MK SELECT ASCII_CHAR
?I000051_F000_000248_P000144 ; L#MK CASE " "  RESULT = DIGIT_N
; CMPNE_BT_NM_LBL F0_U08,32,FALSE_7
        MOVLW 32
        CPFSEQ F0_U08
        BRA FALSE_7
?I000052_F000_000248_P000144 ; L#MK CASE " "  RESULT = DIGIT_N
        CLRF F1_U08,0
        BRA ENDIF_7
FALSE_7
?I000053_F000_000249_P000144 ; L#MK CASE "0"  RESULT = DIGIT_0
; CMPNE_BT_NM_LBL F0_U08,48,FALSE_8
        MOVLW 48
        CPFSEQ F0_U08
        BRA FALSE_8
?I000054_F000_000249_P000144 ; L#MK CASE "0"  RESULT = DIGIT_0
        MOVLW 63
        MOVWF F1_U08,0
        BRA ENDIF_7
FALSE_8
?I000055_F000_000250_P000144 ; L#MK CASE "1"  RESULT = DIGIT_1
; CMPNE_BT_NM_LBL F0_U08,49,FALSE_9
        MOVLW 49
        CPFSEQ F0_U08
        BRA FALSE_9
?I000056_F000_000250_P000144 ; L#MK CASE "1"  RESULT = DIGIT_1
        MOVLW 6
        MOVWF F1_U08,0
        BRA ENDIF_7
FALSE_9
?I000057_F000_000251_P000144 ; L#MK CASE "2"  RESULT = DIGIT_2
; CMPNE_BT_NM_LBL F0_U08,50,FALSE_10
        MOVLW 50
        CPFSEQ F0_U08
        BRA FALSE_10
?I000058_F000_000251_P000144 ; L#MK CASE "2"  RESULT = DIGIT_2
        MOVLW 91
        MOVWF F1_U08,0
        BRA ENDIF_7
FALSE_10
?I000059_F000_000252_P000144 ; L#MK CASE "3"  RESULT = DIGIT_3
; CMPNE_BT_NM_LBL F0_U08,51,FALSE_11
        MOVLW 51
        CPFSEQ F0_U08
        BRA FALSE_11
?I000060_F000_000252_P000144 ; L#MK CASE "3"  RESULT = DIGIT_3
        MOVLW 79
        MOVWF F1_U08,0
        BRA ENDIF_7
FALSE_11
?I000061_F000_000253_P000144 ; L#MK CASE "4"  RESULT = DIGIT_4
; CMPNE_BT_NM_LBL F0_U08,52,FALSE_12
        MOVLW 52
        CPFSEQ F0_U08
        BRA FALSE_12
?I000062_F000_000253_P000144 ; L#MK CASE "4"  RESULT = DIGIT_4
        MOVLW 102
        MOVWF F1_U08,0
        BRA ENDIF_7
FALSE_12
?I000063_F000_000254_P000144 ; L#MK CASE "5"  RESULT = DIGIT_5
; CMPNE_BT_NM_LBL F0_U08,53,FALSE_13
        MOVLW 53
        CPFSEQ F0_U08
        BRA FALSE_13
?I000064_F000_000254_P000144 ; L#MK CASE "5"  RESULT = DIGIT_5
        MOVLW 109
        MOVWF F1_U08,0
        BRA ENDIF_7
FALSE_13
?I000065_F000_000255_P000144 ; L#MK CASE "6"  RESULT = DIGIT_6
; CMPNE_BT_NM_LBL F0_U08,54,FALSE_14
        MOVLW 54
        CPFSEQ F0_U08
        BRA FALSE_14
?I000066_F000_000255_P000144 ; L#MK CASE "6"  RESULT = DIGIT_6
        MOVLW 125
        MOVWF F1_U08,0
        BRA ENDIF_7
FALSE_14
?I000067_F000_000256_P000144 ; L#MK CASE "7"  RESULT = DIGIT_7
; CMPNE_BT_NM_LBL F0_U08,55,FALSE_15
        MOVLW 55
        CPFSEQ F0_U08
        BRA FALSE_15
?I000068_F000_000256_P000144 ; L#MK CASE "7"  RESULT = DIGIT_7
        MOVLW 7
        MOVWF F1_U08,0
        BRA ENDIF_7
FALSE_15
?I000069_F000_000257_P000144 ; L#MK CASE "8"  RESULT = DIGIT_8
; CMPNE_BT_NM_LBL F0_U08,56,FALSE_16
        MOVLW 56
        CPFSEQ F0_U08
        BRA FALSE_16
?I000070_F000_000257_P000144 ; L#MK CASE "8"  RESULT = DIGIT_8
        MOVLW 127
        MOVWF F1_U08,0
        BRA ENDIF_7
FALSE_16
?I000071_F000_000258_P000144 ; L#MK CASE "9"  RESULT = DIGIT_9
; CMPNE_BT_NM_LBL F0_U08,57,FALSE_17
        MOVLW 57
        CPFSEQ F0_U08
        BRA FALSE_17
?I000072_F000_000258_P000144 ; L#MK CASE "9"  RESULT = DIGIT_9
        MOVLW 111
        MOVWF F1_U08,0
        BRA ENDIF_7
FALSE_17
?I000073_F000_000259_P000144 ; L#MK ELSE RESULT = DIGIT_N
        CLRF F1_U08,0
ENDIF_7
?I000074_F000_000261_P000144 ; L#MK END FUNCTION
        RETURN 0
PROC_LED7SEG_DECODE_NUMBER_0
?I000075_F000_000267_P000145 ; L#MK SELECT NUM
?I000076_F000_000268_P000145 ; L#MK CASE 0  RESULT = DIGIT_0
; CMPNE_BT_NM_LBL F0_U08,0,FALSE_18
        TSTFSZ F0_U08,0
        BRA FALSE_18
?I000077_F000_000268_P000145 ; L#MK CASE 0  RESULT = DIGIT_0
        MOVLW 63
        MOVWF F1_U08,0
        BRA ENDIF_8
FALSE_18
?I000078_F000_000269_P000145 ; L#MK CASE 1  RESULT = DIGIT_1
; CMPNE_BT_NM_LBL F0_U08,1,FALSE_19
        DECFSZ F0_U08,0,0
        BRA FALSE_19
?I000079_F000_000269_P000145 ; L#MK CASE 1  RESULT = DIGIT_1
        MOVLW 6
        MOVWF F1_U08,0
        BRA ENDIF_8
FALSE_19
?I000080_F000_000270_P000145 ; L#MK CASE 2  RESULT = DIGIT_2
; CMPNE_BT_NM_LBL F0_U08,2,FALSE_20
        MOVLW 2
        CPFSEQ F0_U08
        BRA FALSE_20
?I000081_F000_000270_P000145 ; L#MK CASE 2  RESULT = DIGIT_2
        MOVLW 91
        MOVWF F1_U08,0
        BRA ENDIF_8
FALSE_20
?I000082_F000_000271_P000145 ; L#MK CASE 3  RESULT = DIGIT_3
; CMPNE_BT_NM_LBL F0_U08,3,FALSE_21
        MOVLW 3
        CPFSEQ F0_U08
        BRA FALSE_21
?I000083_F000_000271_P000145 ; L#MK CASE 3  RESULT = DIGIT_3
        MOVLW 79
        MOVWF F1_U08,0
        BRA ENDIF_8
FALSE_21
?I000084_F000_000272_P000145 ; L#MK CASE 4  RESULT = DIGIT_4
; CMPNE_BT_NM_LBL F0_U08,4,FALSE_22
        MOVLW 4
        CPFSEQ F0_U08
        BRA FALSE_22
?I000085_F000_000272_P000145 ; L#MK CASE 4  RESULT = DIGIT_4
        MOVLW 102
        MOVWF F1_U08,0
        BRA ENDIF_8
FALSE_22
?I000086_F000_000273_P000145 ; L#MK CASE 5  RESULT = DIGIT_5
; CMPNE_BT_NM_LBL F0_U08,5,FALSE_23
        MOVLW 5
        CPFSEQ F0_U08
        BRA FALSE_23
?I000087_F000_000273_P000145 ; L#MK CASE 5  RESULT = DIGIT_5
        MOVLW 109
        MOVWF F1_U08,0
        BRA ENDIF_8
FALSE_23
?I000088_F000_000274_P000145 ; L#MK CASE 6  RESULT = DIGIT_6
; CMPNE_BT_NM_LBL F0_U08,6,FALSE_24
        MOVLW 6
        CPFSEQ F0_U08
        BRA FALSE_24
?I000089_F000_000274_P000145 ; L#MK CASE 6  RESULT = DIGIT_6
        MOVLW 125
        MOVWF F1_U08,0
        BRA ENDIF_8
FALSE_24
?I000090_F000_000275_P000145 ; L#MK CASE 7  RESULT = DIGIT_7
; CMPNE_BT_NM_LBL F0_U08,7,FALSE_25
        MOVLW 7
        CPFSEQ F0_U08
        BRA FALSE_25
?I000091_F000_000275_P000145 ; L#MK CASE 7  RESULT = DIGIT_7
        MOVLW 7
        MOVWF F1_U08,0
        BRA ENDIF_8
FALSE_25
?I000092_F000_000276_P000145 ; L#MK CASE 8  RESULT = DIGIT_8
; CMPNE_BT_NM_LBL F0_U08,8,FALSE_26
        MOVLW 8
        CPFSEQ F0_U08
        BRA FALSE_26
?I000093_F000_000276_P000145 ; L#MK CASE 8  RESULT = DIGIT_8
        MOVLW 127
        MOVWF F1_U08,0
        BRA ENDIF_8
FALSE_26
?I000094_F000_000277_P000145 ; L#MK CASE 9  RESULT = DIGIT_9
; CMPNE_BT_NM_LBL F0_U08,9,ENDIF_8
        MOVLW 9
        CPFSEQ F0_U08
        BRA ENDIF_8
?I000095_F000_000277_P000145 ; L#MK CASE 9  RESULT = DIGIT_9
        MOVLW 111
        MOVWF F1_U08,0
ENDIF_8
?I000096_F000_000279_P000145 ; L#MK END FUNCTION
        RETURN 0
PROC_ROTARY_ENCODER_0
?I000097_F000_000292_P000146 ; L#MK TEMP_A = ENCODER_A
        CLRF WREG,0
        BTFSC PORTA,0,0
        MOVLW 1
        MOVWF F0_U08,0
?I000098_F000_000293_P000146 ; L#MK TEMP_B = ENCODER_B
        CLRF WREG,0
        BTFSC PORTA,1,0
        MOVLW 1
        MOVWF F1_U08,0
?I000099_F000_000295_P000146 ; L#MK RESULT = ENCODER_STOP
        CLRF F2_S08,0
?I000100_F000_000297_P000146 ; L#MK IF (ROTARY_ENC_A = 1) AND (TEMP_A = 0) AND (TEMP_B = 1) THEN
; CMPNE_BT_NM_LBL M1_U08,1,ENDIF_9
        DECFSZ M1_U08,0
        BRA ENDIF_9
; CMPNE_BT_NM_LBL F0_U08,0,ENDIF_9
        TSTFSZ F0_U08,0
        BRA ENDIF_9
; CMPNE_BT_NM_LBL F1_U08,1,ENDIF_9
        DECFSZ F1_U08,0,0
        BRA ENDIF_9
?I000101_F000_000298_P000146 ; L#MK ROTARY_STAT   = CW
        MOVLW 1
        MOVWF M3_S08
?I000102_F000_000299_P000146 ; L#MK ROTARY_A_LOCK = TRUE
        BSF M0_U01,0
ENDIF_9
?I000103_F000_000301_P000146 ; L#MK IF ROTARY_A_LOCK = TRUE THEN
; CMPNE_BI_NM_LBL M0_U01,0,1,ENDIF_10
; CMPNE_NM_BI_LBL 1,M0_U01,0,ENDIF_10
        BCF STATUS,3,0
        BTFSS M0_U01,0
        BSF STATUS,3,0
        BOV ENDIF_10
?I000104_F000_000302_P000146 ; L#MK IF (TEMP_A = 0) AND (TEMP_B = 0) THEN
; CMPNE_BT_NM_LBL F0_U08,0,ENDIF_11
        TSTFSZ F0_U08,0
        BRA ENDIF_11
; CMPNE_BT_NM_LBL F1_U08,0,ENDIF_11
        TSTFSZ F1_U08,0
        BRA ENDIF_11
?I000105_F000_000303_P000146 ; L#MK RESULT = ROTARY_STAT
        MOVFF M3_S08,F2_S08
?I000106_F000_000304_P000146 ; L#MK ROTARY_A_LOCK = FALSE
        BCF M0_U01,0
ENDIF_11
ENDIF_10
?I000107_F000_000308_P000146 ; L#MK IF (ROTARY_ENC_B = 1) AND (TEMP_B = 0) AND (TEMP_A = 1) THEN
; CMPNE_BT_NM_LBL M2_U08,1,ENDIF_12
        DECFSZ M2_U08,0
        BRA ENDIF_12
; CMPNE_BT_NM_LBL F1_U08,0,ENDIF_12
        TSTFSZ F1_U08,0
        BRA ENDIF_12
; CMPNE_BT_NM_LBL F0_U08,1,ENDIF_12
        DECFSZ F0_U08,0,0
        BRA ENDIF_12
?I000108_F000_000309_P000146 ; L#MK ROTARY_STAT   = CCW
        SETF M3_S08
?I000109_F000_000310_P000146 ; L#MK ROTARY_B_LOCK = TRUE
        BSF M0_U01,1
ENDIF_12
?I000110_F000_000312_P000146 ; L#MK IF ROTARY_B_LOCK = TRUE THEN
; CMPNE_BI_NM_LBL M0_U01,1,1,ENDIF_13
; CMPNE_NM_BI_LBL 1,M0_U01,1,ENDIF_13
        BCF STATUS,3,0
        BTFSS M0_U01,1
        BSF STATUS,3,0
        BOV ENDIF_13
?I000111_F000_000313_P000146 ; L#MK IF (TEMP_A = 0) AND (TEMP_B = 0) THEN
; CMPNE_BT_NM_LBL F0_U08,0,ENDIF_14
        TSTFSZ F0_U08,0
        BRA ENDIF_14
; CMPNE_BT_NM_LBL F1_U08,0,ENDIF_14
        TSTFSZ F1_U08,0
        BRA ENDIF_14
?I000112_F000_000314_P000146 ; L#MK RESULT = ROTARY_STAT
        MOVFF M3_S08,F2_S08
?I000113_F000_000315_P000146 ; L#MK ROTARY_B_LOCK = FALSE
        BCF M0_U01,1
ENDIF_14
ENDIF_13
?I000114_F000_000319_P000146 ; L#MK ROTARY_ENC_A = TEMP_A
        MOVFF F0_U08,M1_U08
?I000115_F000_000320_P000146 ; L#MK ROTARY_ENC_B = TEMP_B
        MOVFF F1_U08,M2_U08
?I000116_F000_000321_P000146 ; L#MK END FUNCTION
        RETURN 0
PROC_DECODE_NUMBER_0
?I000117_F000_000330_P000147 ; L#MK LED_TXT = DECTOSTR( NUM, 6, " " )
        CLRF F54_ADRH,0
        MOVLW 67
        MOVWF F54_ADR,0
        MOVFF F38_U32HHH,F11_U32HHH
        MOVFF F38_U32HH,F11_U32HH
        MOVFF F38_U32H,F11_U32H
        MOVFF F38_U32,F11_U32
        MOVLW 6
        MOVWF F15_U08,0
        MOVLW 32
        MOVWF F16_U08,0
        RCALL PROC_OL_10_DECTOSTR_0
        CLRF F56_ADRH,0
        MOVLW 42
        MOVWF F56_ADR,0
        MOVFF F54_ADRH,A0H
        MOVFF F54_ADR,A0
        MOVFF F56_ADRH,A1H
        MOVFF F56_ADR,A1
        MOVF POSTINC1,0,0
        BZ $ + 6
        MOVWF POSTINC0,0
        BRA $ - 6
        CLRF INDF0,0
?I000118_F000_000331_P000147 ; L#MK LED_VAL1 = LED7SEG_DECODE_ASCII( LED_TXT(5) )
        MOVFF F47_U08,F0_U08
        RCALL PROC_LED7SEG_DECODE_ASCII_0
        MOVFF F1_U08,M7_U08
?I000119_F000_000332_P000147 ; L#MK LED_VAL2 = LED7SEG_DECODE_ASCII( LED_TXT(4) )
        MOVFF F46_U08,F0_U08
        RCALL PROC_LED7SEG_DECODE_ASCII_0
        MOVFF F1_U08,M8_U08
?I000120_F000_000333_P000147 ; L#MK LED_VAL3 = LED7SEG_DECODE_ASCII( LED_TXT(3) )
        MOVFF F45_U08,F0_U08
        RCALL PROC_LED7SEG_DECODE_ASCII_0
        MOVFF F1_U08,M9_U08
?I000121_F000_000334_P000147 ; L#MK LED_VAL4 = LED7SEG_DECODE_ASCII( LED_TXT(2) )
        MOVFF F44_U08,F0_U08
        RCALL PROC_LED7SEG_DECODE_ASCII_0
        MOVFF F1_U08,M10_U08
?I000122_F000_000335_P000147 ; L#MK LED_VAL5 = LED7SEG_DECODE_ASCII( LED_TXT(1) )
        MOVFF F43_U08,F0_U08
        RCALL PROC_LED7SEG_DECODE_ASCII_0
        MOVFF F1_U08,M11_U08
?I000123_F000_000336_P000147 ; L#MK LED_VAL6 = LED7SEG_DECODE_ASCII( LED_TXT(0) )
        MOVFF F42_U08,F0_U08
        RCALL PROC_LED7SEG_DECODE_ASCII_0
        MOVFF F1_U08,M12_U08
?I000124_F000_000337_P000147 ; L#MK END SUB
        RETURN 0
PROC_DECODE_NUMBER_SETMODE_0
?I000125_F000_000347_P000148 ; L#MK FOR I = 0 TO 5
        CLRF F9_U08,0
FORNEXT_0
; CMPGT_BT_NM_LBL F9_U08,5,END_FORNEXT_0
        MOVLW 6
        CPFSLT F9_U08
        BRA END_FORNEXT_0
?I000126_F000_000348_P000148 ; L#MK TMP(I) = LED7SEG_DECODE_NUMBER( SET_VAL(I) )
        CLRF F11_ADRH,0
        MOVLW 28
        MOVWF F11_ADR,0
        MOVF F9_U08,0,0
        ADDWF F11_ADR,1,0
        MOVLW 0
        ADDWFC F11_ADRH,1,0
        LFSR 1,M14_U16
        MOVF F9_U08,0,0
        ADDWF A1,1,0
        MOVLW 0
        ADDWFC A1H,1,0
        MOVFF INDF1,F0_U08
        RCALL PROC_LED7SEG_DECODE_NUMBER_0
        MOVFF F11_ADRH,A0H
        MOVFF F11_ADR,A0
        MOVFF F1_U08,INDF0
        INCF F9_U08,1,0
        BRA FORNEXT_0
END_FORNEXT_0
?I000127_F000_000351_P000148 ; L#MK TMP(DP_POS) = TMP(DP_POS) OR DIGIT_DP
        CLRF F11_ADRH,0
        MOVLW 28
        MOVWF F11_ADR,0
        MOVF F2_U08,0,0
        ADDWF F11_ADR,1,0
        MOVLW 0
        ADDWFC F11_ADRH,1,0
        LFSR 1,F3_U16
        MOVF F2_U08,0,0
        ADDWF A1,1,0
        MOVLW 0
        ADDWFC A1H,1,0
        MOVFF INDF1,F15_U08
        MOVLW 128
        IORWF F15_U08,0,0
        MOVWF F10_U08,0
        MOVFF F11_ADRH,A0H
        MOVFF F11_ADR,A0
        MOVFF F10_U08,INDF0
?I000128_F000_000353_P000148 ; L#MK LED_VAL1 = TMP(0)
        MOVFF F3_U08,M7_U08
?I000129_F000_000354_P000148 ; L#MK LED_VAL2 = TMP(1)
        MOVFF F4_U08,M8_U08
?I000130_F000_000355_P000148 ; L#MK LED_VAL3 = TMP(2)
        MOVFF F5_U08,M9_U08
?I000131_F000_000356_P000148 ; L#MK LED_VAL4 = TMP(3)
        MOVFF F6_U08,M10_U08
?I000132_F000_000357_P000148 ; L#MK LED_VAL5 = TMP(4)
        MOVFF F7_U08,M11_U08
?I000133_F000_000358_P000148 ; L#MK LED_VAL6 = TMP(5)
        MOVFF F8_U08,M12_U08
?I000134_F000_000359_P000148 ; L#MK END SUB
        RETURN 0
ISR_ONTIMER_0
   MOVFF STATUS, F58_U08
   MOVFF WREG, F59_U08
   MOVFF BSR, F60_U08
?I000135_F000_000203_P000143 ; L#MK IF TIMER0_OVERFLOWD THEN
; CMPNE_BI_NM_LBL INTCON,2,1,ENDIF_35
; CMPNE_NM_BI_LBL 1,INTCON,2,ENDIF_35
        BTFSS INTCON,2,0
        BRA ENDIF_35
?I000136_F000_000204_P000143 ; L#MK TMR0L = 69
        MOVLW 69
        MOVWF TMR0L,0
?I000137_F000_000205_P000143 ; L#MK SELECT LED_POS
?I000138_F000_000206_P000143 ; L#MK CASE 1
; CMPNE_BT_NM_LBL M13_U08,1,FALSE_31
        DECFSZ M13_U08,0
        BRA FALSE_31
?I000139_F000_000207_P000143 ; L#MK LED_DEV6 = LED_OFF
        BCF LATC,0,0
?I000140_F000_000208_P000143 ; L#MK LED_SEG_PORT = LED_VAL1
        MOVFF M7_U08,LATD
?I000141_F000_000209_P000143 ; L#MK LED_DEV1 = LED_ON
        BSF LATE,2,0
?I000142_F000_000210_P000143 ; L#MK LED_POS = LED_POS + 1
        INCF M13_U08,1
        BRA ENDIF_36
FALSE_31
?I000143_F000_000211_P000143 ; L#MK CASE 2
; CMPNE_BT_NM_LBL M13_U08,2,FALSE_32
        MOVLW 2
        CPFSEQ M13_U08
        BRA FALSE_32
?I000144_F000_000212_P000143 ; L#MK LED_DEV1 = LED_OFF
        BCF LATE,2,0
?I000145_F000_000213_P000143 ; L#MK LED_SEG_PORT = LED_VAL2
        MOVFF M8_U08,LATD
?I000146_F000_000214_P000143 ; L#MK LED_DEV2 = LED_ON
        BSF LATE,1,0
?I000147_F000_000215_P000143 ; L#MK LED_POS = LED_POS + 1
        INCF M13_U08,1
        BRA ENDIF_36
FALSE_32
?I000148_F000_000216_P000143 ; L#MK CASE 3
; CMPNE_BT_NM_LBL M13_U08,3,FALSE_33
        MOVLW 3
        CPFSEQ M13_U08
        BRA FALSE_33
?I000149_F000_000217_P000143 ; L#MK LED_DEV2 = LED_OFF
        BCF LATE,1,0
?I000150_F000_000218_P000143 ; L#MK LED_SEG_PORT = LED_VAL3
        MOVFF M9_U08,LATD
?I000151_F000_000219_P000143 ; L#MK LED_DEV3 = LED_ON
        BSF LATE,0,0
?I000152_F000_000220_P000143 ; L#MK LED_POS = LED_POS + 1
        INCF M13_U08,1
        BRA ENDIF_36
FALSE_33
?I000153_F000_000221_P000143 ; L#MK CASE 4
; CMPNE_BT_NM_LBL M13_U08,4,FALSE_34
        MOVLW 4
        CPFSEQ M13_U08
        BRA FALSE_34
?I000154_F000_000222_P000143 ; L#MK LED_DEV3 = LED_OFF
        BCF LATE,0,0
?I000155_F000_000223_P000143 ; L#MK LED_SEG_PORT = LED_VAL4
        MOVFF M10_U08,LATD
?I000156_F000_000224_P000143 ; L#MK LED_DEV4 = LED_ON
        BSF LATC,2,0
?I000157_F000_000225_P000143 ; L#MK LED_POS = LED_POS + 1
        INCF M13_U08,1
        BRA ENDIF_36
FALSE_34
?I000158_F000_000226_P000143 ; L#MK CASE 5
; CMPNE_BT_NM_LBL M13_U08,5,FALSE_35
        MOVLW 5
        CPFSEQ M13_U08
        BRA FALSE_35
?I000159_F000_000227_P000143 ; L#MK LED_DEV4 = LED_OFF
        BCF LATC,2,0
?I000160_F000_000228_P000143 ; L#MK LED_SEG_PORT = LED_VAL5
        MOVFF M11_U08,LATD
?I000161_F000_000229_P000143 ; L#MK LED_DEV5 = LED_ON
        BSF LATC,1,0
?I000162_F000_000230_P000143 ; L#MK LED_POS = LED_POS + 1
        INCF M13_U08,1
        BRA ENDIF_36
FALSE_35
?I000163_F000_000231_P000143 ; L#MK CASE 6
; CMPNE_BT_NM_LBL M13_U08,6,ENDIF_36
        MOVLW 6
        CPFSEQ M13_U08
        BRA ENDIF_36
?I000164_F000_000232_P000143 ; L#MK LED_DEV5 = LED_OFF
        BCF LATC,1,0
?I000165_F000_000233_P000143 ; L#MK LED_SEG_PORT = LED_VAL6
        MOVFF M12_U08,LATD
?I000166_F000_000234_P000143 ; L#MK LED_DEV6 = LED_ON
        BSF LATC,0,0
?I000167_F000_000235_P000143 ; L#MK LED_POS = 1
        MOVLW 1
        MOVWF M13_U08
ENDIF_36
?I000168_F000_000238_P000143 ; L#MK TIMER0_OVERFLOWD = FALSE   ' CLEAR INTERRUPT FLAG
        BCF INTCON,2,0
ENDIF_35
   MOVFF F60_U08, BSR
   MOVFF F59_U08, WREG
   MOVFF F58_U08, STATUS
?I000169_F000_000240_P000143 ; L#MK END INTERRUPT
        RETFIE
ISR_ONCHANGEPORTB_0
?I000170_F000_000190_P000142 ; L#MK IF PORTB0_CHANGED THEN
; CMPNE_BI_NM_LBL INTCON,1,1,ENDIF_37
; CMPNE_NM_BI_LBL 1,INTCON,1,ENDIF_37
        BTFSS INTCON,1,0
        BRA ENDIF_37
?I000171_F000_000191_P000142 ; L#MK COUNT = COUNT + 1
        INCF M20_U32,1
        MOVLW 0
        ADDWFC M20_U32H,1
        ADDWFC M20_U32HH,1
        ADDWFC M20_U32HHH,1
?I000172_F000_000192_P000142 ; L#MK PORTB0_CHANGED = FALSE
        BCF INTCON,1,0
ENDIF_37
?I000173_F000_000194_P000142 ; L#MK END INTERRUPT
        RETFIE 1
MAIN
        BSF RCON,7,0
?I000174_F000_000370_M000000 ; L#MK PORTB_PULLUPS_DISABLE  = TRUE
        BSF INTCON2,7,0
?I000175_F000_000372_M000000 ; L#MK PORTB0_INT_ENABLE      = TRUE
        BSF INTCON,4,0
?I000176_F000_000373_M000000 ; L#MK PORTB0_INT_RISING_EDGE = TRUE
        BSF INTCON2,6,0
?I000177_F000_000375_M000000 ; L#MK ADCONFIG0 = 1  ' PORTA DIGITAL I/O
        BSF ADCON1,0,0
?I000178_F000_000376_M000000 ; L#MK ADCONFIG1 = 1
        BSF ADCON1,1,0
?I000179_F000_000377_M000000 ; L#MK ADCONFIG2 = 1
        BSF ADCON1,2,0
?I000180_F000_000378_M000000 ; L#MK ADCONFIG3 = 1
        BSF ADCON1,3,0
?I000181_F000_000380_M000000 ; L#MK COMPARATOR_MODE2 = 1 ' COMPATATOR OFF
        BSF CMCON,2,0
?I000182_F000_000381_M000000 ; L#MK COMPARATOR_MODE1 = 1 ' COMPATATOR OFF
        BSF CMCON,1,0
?I000183_F000_000382_M000000 ; L#MK COMPARATOR_MODE0 = 1 ' COMPATATOR OFF
        BSF CMCON,0,0
?I000184_F000_000385_M000000 ; L#MK INPUT(PHOTO_REF_PORT)
        BSF TRISB,0,0
?I000185_F000_000387_M000000 ; L#MK INPUT(ENCODER_A)
        BSF TRISA,0,0
?I000186_F000_000388_M000000 ; L#MK INPUT(ENCODER_B)
        BSF TRISA,1,0
?I000187_F000_000390_M000000 ; L#MK INPUT(SW1)
        BSF TRISB,4,0
?I000188_F000_000391_M000000 ; L#MK INPUT(SW2)
        BSF TRISA,3,0
?I000189_F000_000393_M000000 ; L#MK OUTPUT(RELAY)
        BCF TRISA,5,0
?I000190_F000_000395_M000000 ; L#MK OUTPUT(LED1)
        BCF TRISB,5,0
?I000191_F000_000396_M000000 ; L#MK OUTPUT(LED2)
        BCF TRISB,3,0
?I000192_F000_000397_M000000 ; L#MK OUTPUT(LED3)
        BCF TRISA,2,0
?I000193_F000_000399_M000000 ; L#MK OUTPUT(LED_DEV6)
        BCF TRISC,0,0
?I000194_F000_000400_M000000 ; L#MK OUTPUT(LED_DEV5)
        BCF TRISC,1,0
?I000195_F000_000401_M000000 ; L#MK OUTPUT(LED_DEV4)
        BCF TRISC,2,0
?I000196_F000_000402_M000000 ; L#MK OUTPUT(LED_DEV3)
        BCF TRISE,0,0
?I000197_F000_000403_M000000 ; L#MK OUTPUT(LED_DEV2)
        BCF TRISE,1,0
?I000198_F000_000404_M000000 ; L#MK OUTPUT(LED_DEV1)
        BCF TRISE,2,0
?I000199_F000_000406_M000000 ; L#MK OUTPUT(LED_SEG_A)
        BCF TRISD,0,0
?I000200_F000_000407_M000000 ; L#MK OUTPUT(LED_SEG_B)
        BCF TRISD,1,0
?I000201_F000_000408_M000000 ; L#MK OUTPUT(LED_SEG_C)
        BCF TRISD,2,0
?I000202_F000_000409_M000000 ; L#MK OUTPUT(LED_SEG_D)
        BCF TRISD,3,0
?I000203_F000_000410_M000000 ; L#MK OUTPUT(LED_SEG_E)
        BCF TRISD,4,0
?I000204_F000_000411_M000000 ; L#MK OUTPUT(LED_SEG_F)
        BCF TRISD,5,0
?I000205_F000_000412_M000000 ; L#MK OUTPUT(LED_SEG_G)
        BCF TRISD,6,0
?I000206_F000_000413_M000000 ; L#MK OUTPUT(LED_SEG_DP)
        BCF TRISD,7,0
?I000207_F000_000415_M000000 ; L#MK LED_DEV6 = LED_OFF
        BCF LATC,0,0
?I000208_F000_000416_M000000 ; L#MK LED_DEV5 = LED_OFF
        BCF LATC,1,0
?I000209_F000_000417_M000000 ; L#MK LED_DEV4 = LED_OFF
        BCF LATC,2,0
?I000210_F000_000418_M000000 ; L#MK LED_DEV3 = LED_OFF
        BCF LATE,0,0
?I000211_F000_000419_M000000 ; L#MK LED_DEV2 = LED_OFF
        BCF LATE,1,0
?I000212_F000_000420_M000000 ; L#MK LED_DEV1 = LED_OFF
        BCF LATE,2,0
?I000213_F000_000422_M000000 ; L#MK LED_VAL1 = DIGIT_8
        MOVLW 127
        MOVWF M7_U08
?I000214_F000_000423_M000000 ; L#MK LED_VAL2 = DIGIT_8
        MOVLW 127
        MOVWF M8_U08
?I000215_F000_000424_M000000 ; L#MK LED_VAL3 = DIGIT_8
        MOVLW 127
        MOVWF M9_U08
?I000216_F000_000425_M000000 ; L#MK LED_VAL4 = DIGIT_8
        MOVLW 127
        MOVWF M10_U08
?I000217_F000_000426_M000000 ; L#MK LED_VAL5 = DIGIT_8
        MOVLW 127
        MOVWF M11_U08
?I000218_F000_000427_M000000 ; L#MK LED_VAL6 = DIGIT_8
        MOVLW 127
        MOVWF M12_U08
?I000219_F000_000428_M000000 ; L#MK LED_POS  = 1
        MOVLW 1
        MOVWF M13_U08
?I000220_F000_000432_M000000 ; L#MK TIMER0_PRESCALE_BIT2 = 1   ' PRESCALER 1:128
        BSF T0CON,2,0
?I000221_F000_000433_M000000 ; L#MK TIMER0_PRESCALE_BIT1 = 1   ' PRESCALER 1:128
        BSF T0CON,1,0
?I000222_F000_000434_M000000 ; L#MK TIMER0_PRESCALE_BIT0 = 0   ' PRESCALER 1:128
        BCF T0CON,0,0
?I000223_F000_000435_M000000 ; L#MK TIMER0_PRESCALE_NOT_ASSIGN = FALSE
        BCF T0CON,3,0
?I000224_F000_000436_M000000 ; L#MK TIMER0_MODE_8BIT           = TRUE
        BSF T0CON,6,0
?I000225_F000_000437_M000000 ; L#MK TIMER0_INTERRUPT_ENABLE    = TRUE
        BSF INTCON,5,0
?I000226_F000_000438_M000000 ; L#MK TIMER0_USE_EXTERNAL_CLOCK  = FALSE
        BCF T0CON,5,0
?I000227_F000_000439_M000000 ; L#MK TIMER0_ENABLE              = TRUE
        BSF T0CON,7,0
?I000228_F000_000440_M000000 ; L#MK TIMER0_PRIORITY            = LOW_PRIORITY
        BCF INTCON2,2,0
?I000229_F000_000443_M000000 ; L#MK ENABLE(ONCHANGEPORTB)
        BSF INTCON,7,0
?I000230_F000_000444_M000000 ; L#MK ENABLE(ONTIMER)
        BSF INTCON,6,0
?I000231_F000_000445_M000000 ; L#MK INTERRUPT_PRIORITY    = TRUE
        BSF RCON,7,0
?I000232_F000_000446_M000000 ; L#MK INTERRUPT_HIGH_ENABLE = TRUE
        BSF INTCON,7,0
?I000233_F000_000447_M000000 ; L#MK INTERRUPT_LOW_ENABLE  = TRUE
        BSF INTCON,6,0
?I000234_F000_000449_M000000 ; L#MK ROTARY_ENC_A = ENCODER_A
        CLRF WREG,0
        BTFSC PORTA,0,0
        MOVLW 1
        MOVWF M1_U08
?I000235_F000_000450_M000000 ; L#MK ROTARY_ENC_B = ENCODER_B
        CLRF WREG,0
        BTFSC PORTA,1,0
        MOVLW 1
        MOVWF M2_U08
?I000236_F000_000452_M000000 ; L#MK LED1 = LED_OFF
        BCF LATB,5,0
?I000237_F000_000453_M000000 ; L#MK LED2 = LED_OFF
        BCF LATB,3,0
?I000238_F000_000456_M000000 ; L#MK RELAY = RELAY_OFF
        BSF LATA,5,0
?I000239_F000_000457_M000000 ; L#MK LED3 = LED_OFF
        BCF LATA,2,0
?I000240_F000_000459_M000000 ; L#MK DELAYMS(1000)
        MOVLW 3
        MOVWF SB_SV1H,0
        MOVLW 232
        CALL SBDLYMS16
?I000241_F000_000461_M000000 ; L#MK TARGET_COUNT = READLONGWORD(0)
        CLRF EEADR,0
        RCALL PROC_READLONGWORD_0
        MOVFF F1_U32HHH,M24_U32HHH
        MOVFF F1_U32HH,M24_U32HH
        MOVFF F1_U32H,M24_U32H
        MOVFF F1_U32,M24_U32
?I000242_F000_000462_M000000 ; L#MK COUNT = 0
        CLRF M20_U32HHH
        CLRF M20_U32HH
        CLRF M20_U32H
        CLRF M20_U32
?I000243_F000_000464_M000000 ; L#MK COUNT_STATUS = READY
        CLRF M28_U08
?I000244_F000_000466_M000000 ; L#MK SW1_STATUS = SW_ENABLE
        CLRF M5_U08
?I000245_F000_000467_M000000 ; L#MK SW2_STATUS = SW_ENABLE
        CLRF M6_U08
?I000246_F000_000469_M000000 ; L#MK DP_POS = 0
        CLRF M29_U08
?I000247_F000_000470_M000000 ; L#MK WHILE( TRUE )
WHILE_1
?I000248_F000_000472_M000000 ; L#MK IF SW2 = SW_ON THEN
; CMPNE_BI_NM_LBL PORTA,3,0,ENDIF_15
; CMPNE_NM_BI_LBL 0,PORTA,3,ENDIF_15
        BTFSC PORTA,3,0
        BRA ENDIF_15
?I000249_F000_000473_M000000 ; L#MK IF SW2_STATUS = SW_ENABLE THEN
; CMPNE_BT_NM_LBL M6_U08,0,ENDIF_16
        TSTFSZ M6_U08
        BRA ENDIF_16
?I000250_F000_000475_M000000 ; L#MK IF COUNT_STATUS = READY THEN
; CMPNE_BT_NM_LBL M28_U08,0,FALSE_28
        TSTFSZ M28_U08
        BRA FALSE_28
?I000251_F000_000476_M000000 ; L#MK COUNT_STATUS = SET
        MOVLW 1
        MOVWF M28_U08
?I000252_F000_000478_M000000 ; L#MK TMP_COUNT = READLONGWORD(0)
        CLRF EEADR,0
        CALL PROC_READLONGWORD_0
        MOVFF F1_U32HHH,M30_U32HHH
        MOVFF F1_U32HH,M30_U32HH
        MOVFF F1_U32H,M30_U32H
        MOVFF F1_U32,M30_U32
?I000253_F000_000479_M000000 ; L#MK FOR I = 0 TO 5
        CLRF M34_U08
FORNEXT_1
; CMPGT_BT_NM_LBL M34_U08,5,END_FORNEXT_1
        MOVLW 6
        CPFSLT M34_U08
        BRA END_FORNEXT_1
?I000254_F000_000480_M000000 ; L#MK SET_VAL(I) = TMP_COUNT MOD 10
        LFSR 0,M14_U16
        MOVF M34_U08,0
        ADDWF A0,1,0
        MOVLW 0
        ADDWFC A0H,1,0
        MOVFF M30_U32HHH,SB_SV0HHH
        MOVFF M30_U32HH,SB_SV0HH
        MOVFF M30_U32H,SB_SV0H
        MOVFF M30_U32,SB_SV0
        CLRF SB_SV2HHH,0
        CLRF SB_SV2HH,0
        CLRF SB_SV2H,0
        MOVLW 10
        MOVWF SB_SV2,0
        CALL SB_DIV_U_32X32
        MOVFF SB_SV3,W0_U08
        MOVFF W0_U08,INDF0
?I000255_F000_000481_M000000 ; L#MK TMP_COUNT = TMP_COUNT / 10
        MOVFF M30_U32HHH,SB_SV0HHH
        MOVFF M30_U32HH,SB_SV0HH
        MOVFF M30_U32H,SB_SV0H
        MOVFF M30_U32,SB_SV0
        CLRF SB_SV2HHH,0
        CLRF SB_SV2HH,0
        CLRF SB_SV2H,0
        MOVLW 10
        MOVWF SB_SV2,0
        CALL SB_DIV_U_32X32
        MOVFF SB_SV5HHH,M30_U32HHH
        MOVFF SB_SV5HH,M30_U32HH
        MOVFF SB_SV5H,M30_U32H
        MOVFF SB_SV5,M30_U32
        INCF M34_U08,1
        BRA FORNEXT_1
END_FORNEXT_1
?I000256_F000_000484_M000000 ; L#MK LED1 = LED_ON
        BSF LATB,5,0
        BRA ENDIF_17
FALSE_28
?I000257_F000_000487_M000000 ; L#MK COUNT_STATUS = READY
        CLRF M28_U08
?I000258_F000_000488_M000000 ; L#MK LED1 = LED_OFF
        BCF LATB,5,0
?I000259_F000_000490_M000000 ; L#MK TMP_COUNT = 0
        CLRF M30_U32HHH
        CLRF M30_U32HH
        CLRF M30_U32H
        CLRF M30_U32
?I000260_F000_000491_M000000 ; L#MK MULTIPLE = 1
        CLRF M35_U32HHH
        CLRF M35_U32HH
        CLRF M35_U32H
        MOVLW 1
        MOVWF M35_U32
?I000261_F000_000492_M000000 ; L#MK FOR I = 0 TO 5
        CLRF M34_U08
FORNEXT_2
; CMPGT_BT_NM_LBL M34_U08,5,END_FORNEXT_2
        MOVLW 6
        CPFSLT M34_U08
        BRA END_FORNEXT_2
?I000262_F000_000493_M000000 ; L#MK TMP_COUNT = TMP_COUNT + (LONGWORD(SET_VAL(I)) * MULTIPLE)
        LFSR 1,M14_U16
        MOVF M34_U08,0
        ADDWF A1,1,0
        MOVLW 0
        ADDWFC A1H,1,0
        MOVFF INDF1,W3_U32
        CLRF W3_U32H
        CLRF W3_U32HH
        CLRF W3_U32HHH
        MOVFF W3_U32HHH,SB_SV0HHH
        MOVFF W3_U32HH,SB_SV0HH
        MOVFF W3_U32H,SB_SV0H
        MOVFF W3_U32,SB_SV0
        MOVFF M35_U32HHH,SB_SV2HHH
        MOVFF M35_U32HH,SB_SV2HH
        MOVFF M35_U32H,SB_SV2H
        MOVFF M35_U32,SB_SV2
        CALL SB_MULT32X32
        MOVFF SB_SV0HHH,W7_U32HHH
        MOVFF SB_SV0HH,W7_U32HH
        MOVFF SB_SV0H,W7_U32H
        MOVFF SB_SV0,W7_U32
        MOVF W7_U32,0
        ADDWF M30_U32,1
        MOVF W7_U32H,0
        ADDWFC M30_U32H,1
        MOVF W7_U32HH,0
        ADDWFC M30_U32HH,1
        MOVF W7_U32HHH,0
        ADDWFC M30_U32HHH,1
?I000263_F000_000494_M000000 ; L#MK MULTIPLE = MULTIPLE * 10
        MOVF M35_U32HHH,0
        MULLW 10
        MOVFF PRODL,M35_U32HHH
        MOVF M35_U32HH,0
        MULLW 10
        MOVFF PRODL,M35_U32HH
        MOVF PRODH,0,0
        ADDWF M35_U32HHH,1
        MOVF M35_U32H,0
        MULLW 10
        MOVFF PRODL,M35_U32H
        MOVF PRODH,0,0
        ADDWF M35_U32HH,1
        MOVLW 0
        ADDWFC M35_U32HHH,1
        MOVF M35_U32,0
        MULLW 10
        MOVFF PRODL,M35_U32
        MOVF PRODH,0,0
        ADDWF M35_U32H,1
        MOVLW 0
        ADDWFC M35_U32HH,1
        ADDWFC M35_U32HHH,1
        INCF M34_U08,1
        BRA FORNEXT_2
END_FORNEXT_2
?I000264_F000_000496_M000000 ; L#MK TARGET_COUNT = TMP_COUNT
        MOVFF M30_U32HHH,M24_U32HHH
        MOVFF M30_U32HH,M24_U32HH
        MOVFF M30_U32H,M24_U32H
        MOVFF M30_U32,M24_U32
?I000265_F000_000497_M000000 ; L#MK COUNT        = 0
        CLRF M20_U32HHH
        CLRF M20_U32HH
        CLRF M20_U32H
        CLRF M20_U32
?I000266_F000_000499_M000000 ; L#MK WRITELONGWORD(0, TMP_COUNT)
        CLRF EEADR,0
        MOVFF M30_U32HHH,F0_U32HHH
        MOVFF M30_U32HH,F0_U32HH
        MOVFF M30_U32H,F0_U32H
        MOVFF M30_U32,F0_U32
        CALL PROC_WRITELONGWORD_0
?I000267_F000_000500_M000000 ; L#MK RELAY = RELAY_OFF
        BSF LATA,5,0
?I000268_F000_000501_M000000 ; L#MK LED3 = LED_OFF
        BCF LATA,2,0
ENDIF_17
?I000269_F000_000503_M000000 ; L#MK SW2_STATUS = SW_DISABLE
        MOVLW 1
        MOVWF M6_U08
ENDIF_16
ENDIF_15
?I000270_F000_000507_M000000 ; L#MK IF SW2_STATUS = SW_DISABLE THEN
; CMPNE_BT_NM_LBL M6_U08,1,ENDIF_18
        DECFSZ M6_U08,0
        BRA ENDIF_18
?I000271_F000_000508_M000000 ; L#MK IF SW2 = SW_OFF THEN
; CMPNE_BI_NM_LBL PORTA,3,1,ENDIF_19
; CMPNE_NM_BI_LBL 1,PORTA,3,ENDIF_19
        BTFSC PORTA,3,0
?I000272_F000_000509_M000000 ; L#MK SW2_STATUS = SW_ENABLE
        CLRF M6_U08
ENDIF_19
ENDIF_18
?I000273_F000_000514_M000000 ; L#MK IF COUNT_STATUS = READY THEN
; CMPNE_BT_NM_LBL M28_U08,0,ENDIF_20
        TSTFSZ M28_U08
        BRA ENDIF_20
?I000274_F000_000516_M000000 ; L#MK IF SW1 = SW_ON THEN
; CMPNE_BI_NM_LBL PORTB,4,0,ENDIF_21
; CMPNE_NM_BI_LBL 0,PORTB,4,ENDIF_21
        BTFSC PORTB,4,0
        BRA ENDIF_21
?I000275_F000_000517_M000000 ; L#MK IF SW1_STATUS = SW_ENABLE THEN
; CMPNE_BT_NM_LBL M5_U08,0,ENDIF_22
        TSTFSZ M5_U08
        BRA ENDIF_22
?I000276_F000_000518_M000000 ; L#MK COUNT = 0
        CLRF M20_U32HHH
        CLRF M20_U32HH
        CLRF M20_U32H
        CLRF M20_U32
?I000277_F000_000519_M000000 ; L#MK RELAY = RELAY_OFF
        BSF LATA,5,0
?I000278_F000_000520_M000000 ; L#MK LED3 = LED_OFF
        BCF LATA,2,0
ENDIF_22
?I000279_F000_000522_M000000 ; L#MK SW1_STATUS = SW_DISABLE
        MOVLW 1
        MOVWF M5_U08
ENDIF_21
?I000280_F000_000525_M000000 ; L#MK IF SW1_STATUS = SW_DISABLE THEN
; CMPNE_BT_NM_LBL M5_U08,1,ENDIF_23
        DECFSZ M5_U08,0
        BRA ENDIF_23
?I000281_F000_000526_M000000 ; L#MK IF SW1 = SW_OFF THEN
; CMPNE_BI_NM_LBL PORTB,4,1,ENDIF_24
; CMPNE_NM_BI_LBL 1,PORTB,4,ENDIF_24
        BTFSC PORTB,4,0
?I000282_F000_000527_M000000 ; L#MK SW1_STATUS = SW_ENABLE
        CLRF M5_U08
ENDIF_24
ENDIF_23
?I000283_F000_000531_M000000 ; L#MK IF COUNT = TARGET_COUNT THEN
; CMPNE_DW_DW_LBL M20_U32,M24_U32,ENDIF_25
        MOVF M24_U32,0
        SUBWF M20_U32,0
        BNZ ENDIF_25
        MOVF M24_U32H,0
        SUBWF M20_U32H,0
        BNZ ENDIF_25
        MOVF M24_U32HH,0
        SUBWF M20_U32HH,0
        BNZ ENDIF_25
        MOVF M24_U32HHH,0
        SUBWF M20_U32HHH,0
        BNZ ENDIF_25
?I000284_F000_000532_M000000 ; L#MK RELAY = RELAY_ON
        BCF LATA,5,0
?I000285_F000_000533_M000000 ; L#MK LED3 = LED_ON
        BSF LATA,2,0
ENDIF_25
?I000286_F000_000535_M000000 ; L#MK DECODE_NUMBER( COUNT )
        MOVFF M20_U32HHH,F38_U32HHH
        MOVFF M20_U32HH,F38_U32HH
        MOVFF M20_U32H,F38_U32H
        MOVFF M20_U32,F38_U32
        CALL PROC_DECODE_NUMBER_0
ENDIF_20
?I000287_F000_000539_M000000 ; L#MK IF COUNT_STATUS = SET THEN
; CMPNE_BT_NM_LBL M28_U08,1,ENDIF_26
        DECFSZ M28_U08,0
        BRA ENDIF_26
?I000288_F000_000542_M000000 ; L#MK IF SW1 = SW_ON THEN
; CMPNE_BI_NM_LBL PORTB,4,0,ENDIF_27
; CMPNE_NM_BI_LBL 0,PORTB,4,ENDIF_27
        BTFSC PORTB,4,0
        BRA ENDIF_27
?I000289_F000_000543_M000000 ; L#MK IF SW1_STATUS = SW_ENABLE THEN
; CMPNE_BT_NM_LBL M5_U08,0,ENDIF_28
        TSTFSZ M5_U08
        BRA ENDIF_28
?I000290_F000_000544_M000000 ; L#MK IF DP_POS = 5 THEN
; CMPNE_BT_NM_LBL M29_U08,5,FALSE_29
        MOVLW 5
        CPFSEQ M29_U08
        BRA FALSE_29
?I000291_F000_000545_M000000 ; L#MK DP_POS = 0
        CLRF M29_U08
        BRA ENDIF_29
FALSE_29
?I000292_F000_000547_M000000 ; L#MK DP_POS = DP_POS + 1
        INCF M29_U08,1
ENDIF_29
ENDIF_28
?I000293_F000_000550_M000000 ; L#MK SW1_STATUS = SW_DISABLE
        MOVLW 1
        MOVWF M5_U08
ENDIF_27
?I000294_F000_000553_M000000 ; L#MK IF SW1_STATUS = SW_DISABLE THEN
; CMPNE_BT_NM_LBL M5_U08,1,ENDIF_30
        DECFSZ M5_U08,0
        BRA ENDIF_30
?I000295_F000_000554_M000000 ; L#MK IF SW1 = SW_OFF THEN
; CMPNE_BI_NM_LBL PORTB,4,1,ENDIF_31
; CMPNE_NM_BI_LBL 1,PORTB,4,ENDIF_31
        BTFSC PORTB,4,0
?I000296_F000_000555_M000000 ; L#MK SW1_STATUS = SW_ENABLE
        CLRF M5_U08
ENDIF_31
ENDIF_30
?I000297_F000_000560_M000000 ; L#MK TURN = ROTARY_ENCODER()
        CALL PROC_ROTARY_ENCODER_0
        MOVFF F2_S08,M4_S08
?I000298_F000_000561_M000000 ; L#MK SELECT TURN
?I000299_F000_000562_M000000 ; L#MK CASE CW
; CMPNE_BT_NM_LBL M4_S08,1,FALSE_30
        DECFSZ M4_S08,0
        BRA FALSE_30
?I000300_F000_000563_M000000 ; L#MK IF SET_VAL(DP_POS) < 9 THEN
        LFSR 1,M14_U16
        MOVF M29_U08,0
        ADDWF A1,1,0
        MOVLW 0
        ADDWFC A1H,1,0
        MOVFF INDF1,W2_U08
; CMPGE_BT_NM_LBL W2_U08,9,ENDIF_33
        MOVLW 9
        CPFSLT W2_U08
        BRA ENDIF_33
?I000301_F000_000564_M000000 ; L#MK SET_VAL(DP_POS) = SET_VAL(DP_POS) + 1
        CLRF W1_ADRH
        MOVLW 123
        MOVWF W1_ADR
        MOVF M29_U08,0
        ADDWF W1_ADR,1
        MOVLW 0
        ADDWFC W1_ADRH,1
        LFSR 1,M14_U16
        MOVF M29_U08,0
        ADDWF A1,1,0
        MOVLW 0
        ADDWFC A1H,1,0
        MOVFF INDF1,W5_U08
        INCF W5_U08,0
        MOVWF W0_U08
        MOVFF W1_ADRH,A0H
        MOVFF W1_ADR,A0
        MOVFF W0_U08,INDF0
ENDIF_33
        BRA ENDIF_32
FALSE_30
?I000302_F000_000566_M000000 ; L#MK CASE CCW
; CMPNE_BT_NM_LBL M4_S08,255,ENDIF_32
        INCFSZ M4_S08,0
        BRA ENDIF_32
?I000303_F000_000567_M000000 ; L#MK IF SET_VAL(DP_POS) > 0 THEN
        LFSR 1,M14_U16
        MOVF M29_U08,0
        ADDWF A1,1,0
        MOVLW 0
        ADDWFC A1H,1,0
        MOVFF INDF1,W2_U08
; CMPLE_BT_NM_LBL W2_U08,0,ENDIF_34
        MOVF W2_U08,1
        BZ ENDIF_34
?I000304_F000_000568_M000000 ; L#MK SET_VAL(DP_POS) = SET_VAL(DP_POS) - 1
        CLRF W1_ADRH
        MOVLW 123
        MOVWF W1_ADR
        MOVF M29_U08,0
        ADDWF W1_ADR,1
        MOVLW 0
        ADDWFC W1_ADRH,1
        LFSR 1,M14_U16
        MOVF M29_U08,0
        ADDWF A1,1,0
        MOVLW 0
        ADDWFC A1H,1,0
        MOVFF INDF1,W5_U08
        DECF W5_U08,0
        MOVWF W0_U08
        MOVFF W1_ADRH,A0H
        MOVFF W1_ADR,A0
        MOVFF W0_U08,INDF0
ENDIF_34
ENDIF_32
?I000305_F000_000572_M000000 ; L#MK DECODE_NUMBER_SETMODE( DP_POS )
        MOVFF M29_U08,F2_U08
        CALL PROC_DECODE_NUMBER_SETMODE_0
ENDIF_26
        BRA WHILE_1
?I000306_END; L#MK
SBGLB2
        SLEEP
        BRA SBGLB2
 CONFIG PLLDIV = 5
 CONFIG CPUDIV = OSC1_PLL2
 CONFIG USBDIV = 1
 CONFIG FOSC = HSPLL_HS
 CONFIG IESO = OFF
 CONFIG PWRT = ON
 CONFIG BOR = ON
 CONFIG WDT = OFF
 CONFIG WDTPS = 128
 CONFIG MCLRE = OFF
 CONFIG PBADEN = OFF
 CONFIG STVREN = ON
 CONFIG LVP = OFF
 CONFIG ICPRT = OFF
 CONFIG XINST = OFF
 CONFIG DEBUG = OFF
SB#ASMEND
        END
